org.apache.solr.core

## Class ConfigSetService

- java.lang.Object
- - org.apache.solr.core.ConfigSetService

- Direct Known Subclasses:
    CloudConfigSetService, ConfigSetService.Default

      public abstract class ConfigSetService
      extends Object

  Service class used by the CoreContainer to load ConfigSets for use in SolrCore creation.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `ConfigSetService.Default` The default ConfigSetService.
    `static class` | `ConfigSetService.SchemaCaching` A ConfigSetService that shares schema objects between cores

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected SolrResourceLoader` | `parentLoader`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ConfigSetService(SolrResourceLoader loader)` Create a new ConfigSetService

  - ### Method Summary

    All Methods Static Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `abstract String` | `configName(CoreDescriptor cd)` Return a name for the ConfigSet for a core
    `protected NamedList` | `createConfigSetProperties(CoreDescriptor cd, SolrResourceLoader loader)` Return the ConfigSet properties
    `static ConfigSetService` | `createConfigSetService(NodeConfig nodeConfig, SolrResourceLoader loader, ZkController zkController)`
    `protected abstract SolrResourceLoader` | `createCoreResourceLoader(CoreDescriptor cd)` Create a SolrResourceLoader for a core
    `protected IndexSchema` | `createIndexSchema(CoreDescriptor cd, SolrConfig solrConfig)` Create an IndexSchema object for a core
    `protected SolrConfig` | `createSolrConfig(CoreDescriptor cd, SolrResourceLoader loader)` Create a SolrConfig object for a core
    `ConfigSet` | `getConfig(CoreDescriptor dcore)` Load the ConfigSet for a core

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### parentLoader

          protected final SolrResourceLoader parentLoader

  - ### Constructor Detail

    - #### ConfigSetService

          public ConfigSetService(SolrResourceLoader loader)

      Create a new ConfigSetService
      Parameters:
        `loader` - the CoreContainer's resource loader

  - ### Method Detail

    - #### createConfigSetService

          public static ConfigSetService createConfigSetService(NodeConfig nodeConfig,
                                                                SolrResourceLoader loader,
                                                                ZkController zkController)

    - #### getConfig

          public final ConfigSet getConfig(CoreDescriptor dcore)

      Load the ConfigSet for a core
      Parameters:
        `dcore` - the core's CoreDescriptor
      Returns:
        a ConfigSet

    - #### createSolrConfig

          protected SolrConfig createSolrConfig(CoreDescriptor cd,
                                                SolrResourceLoader loader)

      Create a SolrConfig object for a core
      Parameters:
        `cd` - the core's CoreDescriptor
        `loader` - the core's resource loader
      Returns:
        a SolrConfig object

    - #### createIndexSchema

          protected IndexSchema createIndexSchema(CoreDescriptor cd,
                                                  SolrConfig solrConfig)

      Create an IndexSchema object for a core
      Parameters:
        `cd` - the core's CoreDescriptor
        `solrConfig` - the core's SolrConfig
      Returns:
        an IndexSchema

    - #### createConfigSetProperties

          protected NamedList createConfigSetProperties(CoreDescriptor cd,
                                                        SolrResourceLoader loader)

      Return the ConfigSet properties
      Parameters:
        `cd` - the core's CoreDescriptor
        `loader` - the core's resource loader
      Returns:
        the ConfigSet properties

    - #### createCoreResourceLoader

          protected abstract SolrResourceLoader createCoreResourceLoader(CoreDescriptor cd)

      Create a SolrResourceLoader for a core
      Parameters:
        `cd` - the core's CoreDescriptor
      Returns:
        a SolrResourceLoader

    - #### configName

          public abstract String configName(CoreDescriptor cd)

      Return a name for the ConfigSet for a core
      Parameters:
        `cd` - the core's CoreDescriptor
      Returns:
        a name for the core's ConfigSet

Copyright © 2000-2016 Apache Software Foundation. All Rights Reserved.